This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 496137 - yum downgrade seems to get arch wrong in multilib env
yum downgrade seems to get arch wrong in multilib env
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: yum (Show other bugs)
11
All Linux
medium Severity medium
: ---
: ---
Assigned To: Seth Vidal
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-04-16 15:55 EDT by Peter Robinson
Modified: 2014-01-21 18:09 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-22 00:18:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Patch to obey arches on downgrade (2.26 KB, patch)
2009-04-16 16:42 EDT, James Antill
no flags Details | Diff

  None (edit)
Description Peter Robinson 2009-04-16 15:55:59 EDT
As maintainer of ptlib I was testing a patch on a package to see if it fixed a problem. I installed a new package and wanted it to roll it back to the rawhide version. So I ran the following command but it wants to install the i586 packages and not the x86_64 version like was previously installed.


[root@neo ~]# yum downgrade ptlib*
Loaded plugins: dellsysidplugin2, fastestmirror, refresh-packagekit
Setting up Downgrade Process
Loading mirror speeds from cached hostfile
 * rawhide: mirror.leaseweb.com
 * rawhide-debuginfo: ftp.nluug.nl
 * rpmfusion-free-rawhide: rpmfusion.famillecollet.com
Resolving Dependencies
--> Running transaction check
---> Package ptlib.i586 0:2.6.1-1.fc11 set to be updated
--> Processing Dependency: libsasl2.so.2 for package: ptlib
--> Processing Dependency: libssl.so.8 for package: ptlib
--> Processing Dependency: libldap_r-2.4.so.2 for package: ptlib
--> Processing Dependency: libSDL-1.2.so.0 for package: ptlib
--> Processing Dependency: libcrypto.so.8 for package: ptlib
--> Processing Dependency: libldap-2.4.so.2 for package: ptlib
--> Processing Dependency: liblber-2.4.so.2 for package: ptlib
--> Processing Dependency: libv4l2.so.0 for package: ptlib
---> Package ptlib.x86_64 0:2.6.1-2.fc11 set to be erased
--> Processing Dependency: libpt.so.2.6.1()(64bit) for package: opal
--> Processing Dependency: libpt.so.2.6.1()(64bit) for package: ekiga
---> Package ptlib-debuginfo.x86_64 0:2.6.1-1.fc11 set to be updated
---> Package ptlib-debuginfo.x86_64 0:2.6.1-2.fc11 set to be erased
---> Package ptlib-devel.i586 0:2.6.1-1.fc11 set to be updated
---> Package ptlib-devel.x86_64 0:2.6.1-2.fc11 set to be erased
--> Running transaction check
---> Package SDL.i586 0:1.2.13-9.fc11 set to be updated
---> Package cyrus-sasl-lib.i586 0:2.1.22-22.fc11 set to be updated
--> Processing Dependency: libdb-4.7.so for package: cyrus-sasl-lib
---> Package ekiga.x86_64 0:3.2.0-1.fc11 set to be erased
---> Package libv4l.i586 0:0.5.9-1.fc11 set to be updated
---> Package opal.x86_64 0:3.6.1-1.fc11 set to be erased
--> Processing Dependency: libopal.so.3.6.1()(64bit) for package: opal-devel
--> Processing Dependency: opal = 3.6.1-1.fc11 for package: opal-devel
---> Package openldap.i586 0:2.4.15-3.fc11 set to be updated
---> Package openssl.i686 0:0.9.8k-1.fc11 set to be updated
--> Running transaction check
---> Package db4.i586 0:4.7.25-11.fc11 set to be updated
---> Package opal-devel.x86_64 0:3.6.1-1.fc11 set to be erased
--> Finished Dependency Resolution

Dependencies Resolved

=================================================================================================================================================================================
 Package                                     Arch                               Version                                      Repository                                     Size
=================================================================================================================================================================================
Installing:
 ptlib                                       i586                               2.6.1-1.fc11                                 rawhide                                       1.3 M
 ptlib-debuginfo                             x86_64                             2.6.1-1.fc11                                 rawhide-debuginfo                             3.9 M
 ptlib-devel                                 i586                               2.6.1-1.fc11                                 rawhide                                       344 k
Removing:
 ptlib                                       x86_64                             2.6.1-2.fc11                                 installed                                     4.0 M
 ptlib-debuginfo                             x86_64                             2.6.1-2.fc11                                 installed                                      14 M
 ptlib-devel                                 x86_64                             2.6.1-2.fc11                                 installed                                     1.7 M
Installing for dependencies:
 SDL                                         i586                               1.2.13-9.fc11                                rawhide                                       221 k
 cyrus-sasl-lib                              i586                               2.1.22-22.fc11                               rawhide                                       145 k
 db4                                         i586                               4.7.25-11.fc11                               rawhide                                       669 k
 libv4l                                      i586                               0.5.9-1.fc11                                 rawhide                                        77 k
 openldap                                    i586                               2.4.15-3.fc11                                rawhide                                       337 k
 openssl                                     i686                               0.9.8k-1.fc11                                rawhide                                       1.4 M
Removing for dependencies:
 ekiga                                       x86_64                             3.2.0-1.fc11                                 installed                                      14 M
 opal                                        x86_64                             3.6.1-1.fc11                                 installed                                      12 M
 opal-devel                                  x86_64                             3.6.1-1.fc11                                 installed                                     2.8 M

Transaction Summary
=================================================================================================================================================================================
Install      9 Package(s)         
Update       0 Package(s)         
Remove       6 Package(s)         

Total download size: 8.4 M
Is this ok [y/N]: n
Exiting on user Command
Complete!
Comment 1 James Antill 2009-04-16 16:42:30 EDT
Created attachment 339920 [details]
Patch to obey arches on downgrade

 That's what I get for doing my testing on i386.
 The following patch should mostly dtrt. ... although it'll now not be happy about downgrading from i586 to i386, or x86_64 to i386 -- there's a lot of crack to dtrt. on upgrade here :(.

 Can you confirm it does the right thing in normal usage?
Comment 2 Peter Robinson 2009-04-16 16:49:05 EDT
Is there a test build in koji somewhere I can try?
Comment 3 seth vidal 2009-05-11 10:31:04 EDT
what's in rawhide has something close-ish to this patch. Can you give that one a try?
Comment 4 Peter Robinson 2009-05-11 11:25:17 EDT
Using yum-3.2.22-4.fc11.noarch which is the current one in rawhide AFAICT still gives me the same issues.


[root@neo ~]# yum downgrade ptlib*
Loaded plugins: dellsysidplugin2, fastestmirror, refresh-packagekit
Setting up Downgrade Process
Loading mirror speeds from cached hostfile
 * rawhide: fr2.rpmfind.net
 * rawhide-debuginfo: fr2.rpmfind.net
 * rpmfusion-free-rawhide: fr2.rpmfind.net
Resolving Dependencies
--> Running transaction check
---> Package ptlib.i586 0:2.6.1-1.fc11 set to be updated
--> Processing Dependency: libsasl2.so.2 for package: ptlib
--> Processing Dependency: libssl.so.8 for package: ptlib
--> Processing Dependency: libldap_r-2.4.so.2 for package: ptlib
--> Processing Dependency: libSDL-1.2.so.0 for package: ptlib
--> Processing Dependency: libcrypto.so.8 for package: ptlib
--> Processing Dependency: libldap-2.4.so.2 for package: ptlib
--> Processing Dependency: liblber-2.4.so.2 for package: ptlib
--> Processing Dependency: libv4l2.so.0 for package: ptlib
---> Package ptlib.x86_64 0:2.6.1-3.fc11 set to be erased
--> Processing Dependency: libpt.so.2.6.1()(64bit) for package: ekiga
--> Processing Dependency: libpt.so.2.6.1()(64bit) for package: opal
---> Package ptlib-debuginfo.x86_64 0:2.6.1-1.fc11 set to be updated
---> Package ptlib-debuginfo.x86_64 0:2.6.1-3.fc11 set to be erased
---> Package ptlib-devel.i586 0:2.6.1-1.fc11 set to be updated
---> Package ptlib-devel.x86_64 0:2.6.1-3.fc11 set to be erased
--> Running transaction check
---> Package SDL.i586 0:1.2.13-9.fc11 set to be updated
---> Package cyrus-sasl-lib.i586 0:2.1.22-22.fc11 set to be updated
--> Processing Dependency: libdb-4.7.so for package: cyrus-sasl-lib
---> Package ekiga.x86_64 0:3.2.0-2.fc11 set to be erased
---> Package libv4l.i586 0:0.5.9-1.fc11 set to be updated
---> Package opal.x86_64 0:3.6.1-3.fc11 set to be erased
--> Processing Dependency: libopal.so.3.6.1()(64bit) for package: opal-devel
--> Processing Dependency: opal = 3.6.1-3.fc11 for package: opal-devel
---> Package openldap.i586 0:2.4.15-3.fc11 set to be updated
---> Package openssl.i686 0:0.9.8k-1.fc11 set to be updated
--> Running transaction check
---> Package db4.i586 0:4.7.25-11.fc11 set to be updated
---> Package opal-devel.x86_64 0:3.6.1-3.fc11 set to be erased
--> Finished Dependency Resolution

Dependencies Resolved

=================================================================================================================================================================================
 Package                                     Arch                               Version                                      Repository                                     Size
=================================================================================================================================================================================
Installing:
 ptlib                                       i586                               2.6.1-1.fc11                                 rawhide                                       1.3 M
 ptlib-debuginfo                             x86_64                             2.6.1-1.fc11                                 rawhide-debuginfo                             3.9 M
 ptlib-devel                                 i586                               2.6.1-1.fc11                                 rawhide                                       345 k
Removing:
 ptlib                                       x86_64                             2.6.1-3.fc11                                 installed                                     4.0 M
 ptlib-debuginfo                             x86_64                             2.6.1-3.fc11                                 installed                                      14 M
 ptlib-devel                                 x86_64                             2.6.1-3.fc11                                 installed                                     1.7 M
Installing for dependencies:
 SDL                                         i586                               1.2.13-9.fc11                                rawhide                                       221 k
 cyrus-sasl-lib                              i586                               2.1.22-22.fc11                               rawhide                                       145 k
 db4                                         i586                               4.7.25-11.fc11                               rawhide                                       669 k
 libv4l                                      i586                               0.5.9-1.fc11                                 rawhide                                        78 k
 openldap                                    i586                               2.4.15-3.fc11                                rawhide                                       338 k
 openssl                                     i686                               0.9.8k-1.fc11                                rawhide                                       1.4 M
Removing for dependencies:
 ekiga                                       x86_64                             3.2.0-2.fc11                                 installed                                      14 M
 opal                                        x86_64                             3.6.1-3.fc11                                 installed                                      12 M
 opal-devel                                  x86_64                             3.6.1-3.fc11                                 installed                                     2.8 M

Transaction Summary
=================================================================================================================================================================================
Install      9 Package(s)         
Update       0 Package(s)         
Remove       6 Package(s)         

Total download size: 8.4 M
Is this ok [y/N]:
Comment 5 Peter Robinson 2009-06-04 08:14:09 EDT
It seems also the downgrade will remove dependent packages even if there is no change in the soname


[root@neo yum.repos.d]# yum downgrade gupnp
Loaded plugins: dellsysidplugin2, fastestmirror, refresh-packagekit
Setting up Downgrade Process
Loading mirror speeds from cached hostfile
 * fedora: mirror.ovh.net
 * rpmfusion-free: ftp-stud.hs-esslingen.de
 * rpmfusion-free-updates: ftp-stud.hs-esslingen.de
 * rpmfusion-free-updates-testing: ftp-stud.hs-esslingen.de
 * updates: mirror.ox.ac.uk
 * updates-testing: mirror.ox.ac.uk
No Match for available package: gupnp-0.12.7-1.fc11.i586
Resolving Dependencies
--> Running transaction check
---> Package gupnp.x86_64 0:0.12.7-1.fc11 set to be updated
---> Package gupnp.x86_64 0:0.12.8-1.fc11 set to be erased
--> Processing Dependency: gupnp = 0.12.8-1.fc11 for package: gupnp-devel-0.12.8-1.fc11.x86_64
--> Running transaction check
---> Package gupnp-devel.x86_64 0:0.12.8-1.fc11 set to be erased
--> Processing Dependency: pkgconfig(gupnp-1.0) for package: gupnp-ui-devel-0.1.1-3.fc11.x86_64
--> Processing Dependency: pkgconfig(gupnp-1.0) for package: gupnp-av-devel-0.4-2.fc11.x86_64
--> Processing Dependency: gupnp-devel for package: gupnp-av-devel-0.4-2.fc11.x86_64
--> Running transaction check
---> Package gupnp-av-devel.x86_64 0:0.4-2.fc11 set to be erased
---> Package gupnp-ui-devel.x86_64 0:0.1.1-3.fc11 set to be erased
--> Finished Dependency Resolution

Dependencies Resolved

===============================================================================================================================================================================================================
 Package                                              Arch                                         Version                                               Repository                                       Size
===============================================================================================================================================================================================================
Installing:
 gupnp                                                x86_64                                       0.12.7-1.fc11                                         fedora                                           70 k
Removing:
 gupnp                                                x86_64                                       0.12.8-1.fc11                                         installed                                       171 k
Removing for dependencies:
 gupnp-av-devel                                       x86_64                                       0.4-2.fc11                                            installed                                        28 k
 gupnp-devel                                          x86_64                                       0.12.8-1.fc11                                         installed                                        57 k
 gupnp-ui-devel                                       x86_64                                       0.1.1-3.fc11                                          installed                                        36 k

Transaction Summary
===============================================================================================================================================================================================================
Install      1 Package(s)         
Update       0 Package(s)         
Remove       4 Package(s)         

Total download size: 70 k
Is this ok [y/N]: y
Downloading Packages:
gupnp-0.12.7-1.fc11.x86_64.rpm                                                                                                                                                          |  70 kB     00:00     
Running rpm_check_debug
Running Transaction Test
Finished Transaction Test
Transaction Test Succeeded
Running Transaction
  Installing     : gupnp-0.12.7-1.fc11.x86_64                                                                                                                                                              1/5 
  Erasing        : gupnp-ui-devel-0.1.1-3.fc11.x86_64                                                                                                                                                      2/5 
  Cleanup        : gupnp-0.12.8-1.fc11.x86_64                                                                                                                                                              3/5 
  Erasing        : gupnp-devel-0.12.8-1.fc11.x86_64                                                                                                                                                        4/5 
  Erasing        : gupnp-av-devel-0.4-2.fc11.x86_64                                                                                                                                                        5/5 

Removed:
  gupnp.x86_64 0:0.12.8-1.fc11                                                                                                                                                                                 

Dependency Removed:
  gupnp-av-devel.x86_64 0:0.4-2.fc11                                  gupnp-devel.x86_64 0:0.12.8-1.fc11                                  gupnp-ui-devel.x86_64 0:0.1.1-3.fc11                                 

Installed:
  gupnp.x86_64 0:0.12.7-1.fc11                                                                                                                                                                                 

Complete!
[root@neo yum.repos.d]#
Comment 6 James Antill 2009-06-04 09:51:34 EDT
 There's a 3.2.23 in both real rawhide and updates-testing for Fed-10 and Fed-11, which should fix the original problem.

> It seems also the downgrade will remove dependent packages even if there is no
> change in the soname

 The problem here is:

--> Processing Dependency: gupnp = 0.12.8-1.fc11 for package:
gupnp-devel-0.12.8-1.fc11.x86_64

...gupnp-devel requires the exact version of gupnp, so when you downgrade gupnp that requirement is broken. The yum depsolver knows to fix this up on upgrade by trying to upgrade gupnp-devel too, downgrade not so much.
 "yum downgrade gupnp\*" should work.
Comment 7 Bug Zapper 2009-06-09 09:57:38 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 11 development cycle.
Changing version to '11'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Adam Miller 2009-06-26 15:17:26 EDT
This has been discussed and there is no need to reinvent the wheel on this matter. Closing as WONTFIX.
Comment 9 Adam Miller 2009-06-26 15:19:11 EDT
Sorry, wrong tab in my browser. That response was supposed to be to https://bugzilla.redhat.com/show_bug.cgi?id=486208.
Comment 10 Peter Robinson 2009-07-21 16:49:36 EDT
(In reply to comment #6)
>  There's a 3.2.23 in both real rawhide and updates-testing for Fed-10 and
> Fed-11, which should fix the original problem.

It seems to work quite well now

> > It seems also the downgrade will remove dependent packages even if there is no
> > change in the soname
> 
>  The problem here is:
> 
> --> Processing Dependency: gupnp = 0.12.8-1.fc11 for package:
> gupnp-devel-0.12.8-1.fc11.x86_64
> 
> ...gupnp-devel requires the exact version of gupnp, so when you downgrade gupnp
> that requirement is broken. The yum depsolver knows to fix this up on upgrade
> by trying to upgrade gupnp-devel too, downgrade not so much.
>  "yum downgrade gupnp\*" should work.  

So is that seen as a bug or should this be now closed?
Comment 11 James Antill 2009-07-22 00:18:52 EDT
 It's a known possible future RFE (to make the depsolver work as well for downgrades as upgrades) ... but it's not going to happen tomorrow :).

Note You need to log in before you can comment on or make changes to this bug.